// Generated by CoffeeScript 1.12.6
(function() {
  var Command, Logger, MeshbluConfig, MeshbluConnectorRunner, _, dashdash, fs, isRunning, path,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  _ = require('lodash');

  dashdash = require('dashdash');

  fs = require('fs-extra');

  path = require('path');

  MeshbluConfig = require('meshblu-config');

  isRunning = require('is-running');

  MeshbluConnectorRunner = require('./index');

  Logger = require('./logger');

  Command = (function() {
    function Command(arg) {
      var argv, connectorPath, meshbluConfig;
      argv = arg.argv;
      this._verifyParentPid = bind(this._verifyParentPid, this);
      this._getParentPid = bind(this._getParentPid, this);
      this._getConnectorPath = bind(this._getConnectorPath, this);
      this._dieWithErrors = bind(this._dieWithErrors, this);
      this.stop = bind(this.stop, this);
      this.run = bind(this.run, this);
      this.panic = bind(this.panic, this);
      this.args = dashdash.parse({
        argv: argv,
        options: []
      });
      connectorPath = this._getConnectorPath();
      meshbluConfig = new MeshbluConfig().toJSON();
      fs.mkdirsSync(path.join(connectorPath, 'log'));
      this.parentPid = this._getParentPid();
      this.logger = new Logger({
        connectorPath: connectorPath
      });
      this.meshbluConnectorRunner = new MeshbluConnectorRunner({
        connectorPath: connectorPath,
        meshbluConfig: meshbluConfig,
        logger: this.logger
      });
      if (!this.meshbluConnectorRunner.isValid()) {
        return this._dieWithErrors(this.meshbluConnectorRunner.errors());
      }
      this.meshbluConnectorRunner.on('error', (function(_this) {
        return function(error) {
          return _this._dieWithErrors([error]);
        };
      })(this));
    }

    Command.prototype.panic = function(error) {
      var ref;
      if ((ref = this.logger) != null) {
        ref.fatal(error);
      }
      console.error(error.stack);
      return process.exit(1);
    };

    Command.prototype.run = function() {
      process.stdout.on('error', (function(_this) {
        return function(error) {
          return _this.logger.error(error.message);
        };
      })(this));
      process.stderr.on('error', (function(_this) {
        return function(error) {
          return _this.logger.error(error.message);
        };
      })(this));
      process.on('SIGINT', this.stop);
      process.on('SIGTERM', this.stop);
      if (this.parentPid != null) {
        setInterval(this._verifyParentPid, 30000);
      }
      return this.meshbluConnectorRunner.run();
    };

    Command.prototype.stop = function() {
      return this.meshbluConnectorRunner.stop((function(_this) {
        return function(error) {
          if (error != null) {
            return _this.panic(error);
          }
          return process.exit(0);
        };
      })(this));
    };

    Command.prototype._dieWithErrors = function(errors) {
      console.error('ERROR:');
      _.each(errors, (function(_this) {
        return function(error) {
          var ref;
          if ((ref = _this.logger) != null) {
            ref.fatal(error);
          }
          return console.error(error.message);
        };
      })(this));
      return process.exit(1);
    };

    Command.prototype._getConnectorPath = function() {
      var connectorPath;
      if (!_.last(this.args)) {
        return process.cwd();
      }
      connectorPath = _.last(this.argv);
      return path.resolve(connectorPath);
    };

    Command.prototype._getParentPid = function() {
      var data, ref;
      try {
        data = JSON.parse(fs.readFileSync('./update.json'));
      } catch (error1) {
        return;
      }
      if (data == null) {
        return;
      }
      return (ref = data.Pid) != null ? ref : data.pid;
    };

    Command.prototype._verifyParentPid = function() {
      var pid;
      pid = this._getParentPid();
      if ((pid != null) && pid === this.parentPid && isRunning(pid)) {
        return;
      }
      return this.meshbluConnectorRunner.stop((function(_this) {
        return function(error) {
          if (error != null) {
            _this.logger.error(error, 'Error on meshbluConnectorRunner.stop');
          }
          if (pid == null) {
            return _this.panic(new Error('update.json is not readable, assuming parent process is no longer running'));
          }
          if (pid !== _this.parentPid) {
            return _this.panic(new Error('Parent process changed'));
          }
          if (!isRunning(pid)) {
            return _this.panic(new Error('Parent process is no longer running'));
          }
        };
      })(this));
    };

    return Command;

  })();

  module.exports = Command;

}).call(this);

//# sourceMappingURL=command.js.map
