// Generated by CoffeeScript 1.12.6
(function() {
  var EventEmitter, Logger, MeshbluConnectorRunner, Runner, _, fs, path,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  _ = require('lodash');

  fs = require('fs');

  path = require('path');

  Runner = require('./runner');

  EventEmitter = require('events').EventEmitter;

  Logger = require('./logger');

  MeshbluConnectorRunner = (function(superClass) {
    extend(MeshbluConnectorRunner, superClass);

    function MeshbluConnectorRunner(arg) {
      var logType, ref;
      ref = arg != null ? arg : {}, this.connectorPath = ref.connectorPath, this.meshbluConfig = ref.meshbluConfig, this.logger = ref.logger, logType = ref.logType;
      this.isValidMeshbluConfig = bind(this.isValidMeshbluConfig, this);
      this.isValidConnector = bind(this.isValidConnector, this);
      this.getPackageJSON = bind(this.getPackageJSON, this);
      this.isValid = bind(this.isValid, this);
      this.errors = bind(this.errors, this);
      this.stop = bind(this.stop, this);
      this.run = bind(this.run, this);
      if (this.connectorPath == null) {
        throw new Error('MeshbluConnectorRunner requires connectorPath');
      }
      if (this.meshbluConfig == null) {
        throw new Error('MeshbluConnectorRunner requires meshbluConfig');
      }
      if (this.logger == null) {
        this.logger = new Logger({
          connectorPath: this.connectorPath,
          logType: logType
        });
      }
    }

    MeshbluConnectorRunner.prototype.run = function() {
      if (!this.isValid()) {
        throw new Error('Invalid state: ', this.errors());
      }
      this.runner = new Runner({
        connectorPath: this.connectorPath,
        meshbluConfig: this.meshbluConfig,
        logger: this.logger
      });
      this.runner.on('error', (function(_this) {
        return function(error) {
          console.error("Runner error:", error.stack);
          console.log("Fatal error, exiting.");
          return process.exit(1);
        };
      })(this));
      return this.runner.run();
    };

    MeshbluConnectorRunner.prototype.stop = function(callback) {
      if (this.runner == null) {
        return;
      }
      return this.runner.close(callback);
    };

    MeshbluConnectorRunner.prototype.errors = function() {
      var errors;
      errors = [];
      if (!this.isValidConnector()) {
        errors.push(new Error('Invalid connector, missing package.json'));
      }
      if (!this.isValidMeshbluConfig()) {
        errors.push(new Error('Invalid meshbluConfig'));
      }
      return errors;
    };

    MeshbluConnectorRunner.prototype.isValid = function() {
      return _.isEmpty(this.errors());
    };

    MeshbluConnectorRunner.prototype.getPackageJSON = function() {
      var packageJSONPath;
      packageJSONPath = path.join(this.connectorPath, 'package.json');
      return require(packageJSONPath);
    };

    MeshbluConnectorRunner.prototype.isValidConnector = function() {
      var packageJSONPath;
      packageJSONPath = path.join(this.connectorPath, 'package.json');
      return fs.existsSync(packageJSONPath);
    };

    MeshbluConnectorRunner.prototype.isValidMeshbluConfig = function() {
      var ref, token, uuid;
      ref = this.meshbluConfig, uuid = ref.uuid, token = ref.token;
      return (uuid != null) && (token != null);
    };

    return MeshbluConnectorRunner;

  })(EventEmitter);

  module.exports = MeshbluConnectorRunner;

}).call(this);

//# sourceMappingURL=index.js.map
