// Generated by CoffeeScript 1.12.6
(function() {
  var Logger, debug, path,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  path = require('path');

  debug = require('debug')('meshblu-connector-runner');

  Logger = (function() {
    function Logger(arg) {
      this.connectorPath = arg.connectorPath, this.logType = arg.logType;
      this._createLogger = bind(this._createLogger, this);
      this._createBunyanLogger = bind(this._createBunyanLogger, this);
      this._createConsoleLogger = bind(this._createConsoleLogger, this);
      if (this.logType === 'console') {
        return this._createConsoleLogger();
      }
      return this._createLogger();
    }

    Logger.prototype._createConsoleLogger = function() {
      return {
        trace: console.info,
        debug: debug,
        info: console.log,
        warn: console.log,
        error: console.error,
        fatal: console.error
      };
    };

    Logger.prototype._createBunyanLogger = function() {
      var bunyan;
      bunyan = require('bunyan');
      return bunyan.createLogger({
        name: path.basename(this.connectorPath),
        streams: [
          {
            level: 'error',
            type: 'rotating-file',
            path: path.join(this.connectorPath, 'log', 'meshblu-connector-runner-error.log'),
            period: '1d',
            count: 3
          }
        ]
      });
    };

    Logger.prototype._createLogger = function() {
      try {
        return this._createBunyanLogger();
      } catch (error) {}
      return this._createConsoleLogger();
    };

    return Logger;

  })();

  module.exports = Logger;

}).call(this);

//# sourceMappingURL=logger.js.map
