// Generated by CoffeeScript 1.12.6
(function() {
  var EventEmitter, MeshbluSocketIO, MessageHandler, Runner, StatusDevice, _, async, path,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  _ = require('lodash');

  path = require('path');

  async = require('async');

  MeshbluSocketIO = require('meshblu');

  StatusDevice = require('./status-device');

  MessageHandler = require('./message-handler');

  EventEmitter = require('events').EventEmitter;

  Runner = (function(superClass) {
    extend(Runner, superClass);

    function Runner(arg) {
      var base, connectorPackageJSONPath, meshbluConfig, ref;
      ref = arg != null ? arg : {}, meshbluConfig = ref.meshbluConfig, this.connectorPath = ref.connectorPath, this.logger = ref.logger;
      this._handleError = bind(this._handleError, this);
      this.whoami = bind(this.whoami, this);
      this.run = bind(this.run, this);
      this._onError = bind(this._onError, this);
      this._handleNotReady = bind(this._handleNotReady, this);
      this._handleMessageHandlerResponse = bind(this._handleMessageHandlerResponse, this);
      this._exitIfStoppedChanged = bind(this._exitIfStoppedChanged, this);
      this._getStoppedState = bind(this._getStoppedState, this);
      this._closeStatusDevice = bind(this._closeStatusDevice, this);
      this._closeMeshblu = bind(this._closeMeshblu, this);
      this._closeConnector = bind(this._closeConnector, this);
      this.close = bind(this.close, this);
      this._checkOnline = bind(this._checkOnline, this);
      this.boot = bind(this.boot, this);
      if (meshbluConfig == null) {
        throw new Error('Missing required parameter: meshbluConfig');
      }
      if (this.connectorPath == null) {
        throw new Error('Missing required parameter: connectorPath');
      }
      if (!this.logger) {
        throw new Error('Missing required parameter: logger');
      }
      this.logger.debug('connectorPath', this.connectorPath);
      this.meshbluConfig = _.cloneDeep(meshbluConfig);
      if ((base = this.meshbluConfig).options == null) {
        base.options = {
          reconnectionAttempts: 20
        };
      }
      this.failedConnectionAttempts = 0;
      this.Connector = require(this.connectorPath);
      connectorPackageJSONPath = path.join(this.connectorPath, 'package.json');
      try {
        this.ConnectorPackageJSON = require(connectorPackageJSONPath);
      } catch (error1) {}
      this.checkOnline = _.throttle(this._checkOnline, 1000, {
        leading: true,
        trailing: false
      });
    }

    Runner.prototype.boot = function(device, callback) {
      var base, base1, base2, base3;
      this.stopped = this._getStoppedState(device);
      this.logger.debug('booting up connector', {
        uuid: device.uuid
      });
      this.connector = new this.Connector({
        logger: this.logger
      });
      if ((base = this.connector).start == null) {
        base.start = (function(_this) {
          return function(device, callback) {
            return callback();
          };
        })(this);
      }
      if (typeof (base1 = this.connector).on === "function") {
        base1.on('error', (function(_this) {
          return function(error) {
            if (error == null) {
              return;
            }
            _this.logger.error('connector emitted error', error);
            return _this.statusDevice.logError({
              error: error
            });
          };
        })(this));
      }
      if (typeof (base2 = this.connector).on === "function") {
        base2.on('message', (function(_this) {
          return function(message) {
            if (_this.stopped) {
              return;
            }
            _this.logger.debug('sending message', message);
            return _this.meshblu.message(message, function(error) {
              if (error != null) {
                return _this.logger.error(error, 'on message');
              }
            });
          };
        })(this));
      }
      if (typeof (base3 = this.connector).on === "function") {
        base3.on('update', (function(_this) {
          return function(properties) {
            var ref, token, uuid;
            if (_this.stopped) {
              return;
            }
            _this.logger.debug('sending update', properties);
            ref = _this.meshbluConfig, uuid = ref.uuid, token = ref.token;
            properties = _.extend({
              uuid: uuid,
              token: token
            }, properties);
            return _this.meshblu.update(properties, function(result) {
              return _this.logger.debug('meshblu update result', result);
            });
          };
        })(this));
      }
      return this.connector.start(device, (function(_this) {
        return function(error) {
          var ref, ref1;
          if (error != null) {
            return _this._onError(error, callback);
          }
          _this.messageHandler = new MessageHandler({
            connector: _this.connector,
            connectorPath: _this.connectorPath,
            logger: _this.logger,
            defaultJobType: (ref = _this.ConnectorPackageJSON) != null ? (ref1 = ref.connector) != null ? ref1.defaultJobType : void 0 : void 0
          });
          _this.meshblu.on('message', function(message) {
            var fromUuid, respondTo;
            if (_this.stopped) {
              return _this.logger.debug('@meshblu.on "message" ignored cause stopped');
            }
            _this.logger.debug('@meshblu.on "message"');
            fromUuid = _.get(message, 'fromUuid');
            respondTo = _.get(message, 'metadata.respondTo');
            return _this.messageHandler.onMessage(message, function(error, response) {
              if (error != null) {
                _this._onError(error);
              }
              return _this._handleMessageHandlerResponse({
                fromUuid: fromUuid,
                respondTo: respondTo,
                error: error,
                response: response
              });
            });
          });
          _this.meshblu.on('config', function(device) {
            var base4;
            _this.logger.debug('@meshblu.on "config"');
            _this._exitIfStoppedChanged(device);
            if (_this.stopped) {
              return _this.logger.debug('@meshblu.on "config" ignored cause stopped');
            }
            return typeof (base4 = _this.connector).onConfig === "function" ? base4.onConfig(device, function(error) {
              if (error != null) {
                return _this._onError(error);
              }
            }) : void 0;
          });
          return callback();
        };
      })(this));
    };

    Runner.prototype._checkOnline = function(callback) {
      this.logger.debug('checking online');
      if (this.connector == null) {
        return;
      }
      if (this.connector.isOnline == null) {
        return callback(null, {
          running: true
        });
      }
      return this.connector.isOnline(callback);
    };

    Runner.prototype.close = function(callback) {
      var tasks;
      if (callback == null) {
        callback = _.noop;
      }
      this.logger.debug('closing');
      this.stopped = true;
      tasks = [this._closeConnector, this._closeMeshblu, this._closeStatusDevice];
      return async.series(tasks, callback);
    };

    Runner.prototype._closeConnector = function(callback) {
      this.logger.debug('close connector');
      if (this.connector == null) {
        return callback();
      }
      return this.connector.close(callback);
    };

    Runner.prototype._closeMeshblu = function(callback) {
      this.logger.debug('close meshblu');
      if (this.connector == null) {
        return callback();
      }
      if (this.meshblu == null) {
        return callback();
      }
      return this.meshblu.close(callback);
    };

    Runner.prototype._closeStatusDevice = function(callback) {
      this.logger.debug('close statusDevice');
      if (!this.statusDevice) {
        return callback();
      }
      return this.statusDevice.close(callback);
    };

    Runner.prototype._getStoppedState = function(device) {
      return _.get(device, 'connectorMetadata.stopped', false);
    };

    Runner.prototype._exitIfStoppedChanged = function(device) {
      var stopped;
      stopped = this._getStoppedState(device);
      if (stopped === this.stopped) {
        return;
      }
      return this.close((function(_this) {
        return function() {
          return process.exit(0);
        };
      })(this));
    };

    Runner.prototype._handleMessageHandlerResponse = function(arg) {
      var data, devices, error, fromUuid, metadata, ref, respondTo, response;
      fromUuid = arg.fromUuid, respondTo = arg.respondTo, error = arg.error, response = arg.response;
      devices = [fromUuid];
      if (error != null) {
        metadata = {
          code: (ref = error.code) != null ? ref : 500,
          error: {
            message: error.message
          }
        };
        if (respondTo != null) {
          metadata.to = respondTo;
        }
        return this.meshblu.message({
          devices: devices,
          metadata: metadata,
          topic: 'error'
        }, (function(_this) {
          return function() {};
        })(this));
      }
      if (!_.isEmpty(response)) {
        data = response.data, metadata = response.metadata;
        if (respondTo != null) {
          if (metadata == null) {
            metadata = {};
          }
          metadata.to = respondTo;
        }
        return this.meshblu.message({
          devices: devices,
          data: data,
          metadata: metadata,
          topic: 'response'
        }, (function(_this) {
          return function() {};
        })(this));
      }
    };

    Runner.prototype._handleNotReady = function(error) {
      if ((error != null ? error.status : void 0) === 504) {
        this.failedConnectionAttempts++;
      }
      if (this.failedConnectionAttempts < 20) {
        return this.emit('notReady', error);
      } else {
        error = new Error('Exceeded number of reconnect attempts for meshblu');
        return this.emit('error', error);
      }
    };

    Runner.prototype._onError = function(error, callback) {
      this.logger.error('_onError', {
        error: error
      });
      this.statusDevice.logError({
        error: error
      });
      if (!_.isFunction(callback)) {
        return;
      }
      return callback(error);
    };

    Runner.prototype.run = function(_callback) {
      var callback;
      if (_callback == null) {
        _callback = _.noop;
      }
      this.logger.debug('running...');
      callback = _.once(_callback);
      this.meshblu = new MeshbluSocketIO(this.meshbluConfig);
      this.meshblu.on('error', this._handleError);
      this.meshblu.on('notReady', (function(_this) {
        return function(error) {
          _this.logger.warn('meshblu notReady', error);
          return _this._handleNotReady(error);
        };
      })(this));
      this.meshblu.once('ready', (function(_this) {
        return function() {
          _this.failedConnectionAttempts = 0;
          _this.meshblu.update({
            uuid: _this.meshbluConfig.uuid,
            'connectorMetadata.currentVersion': _this.ConnectorPackageJSON.version
          }, function() {});
          return _this.whoami(function(error, device) {
            if (error != null) {
              return _this.emit('error', error);
            }
            _this.statusDevice = new StatusDevice({
              meshbluConfig: _this.meshbluConfig,
              meshblu: _this.meshblu,
              device: device,
              checkOnline: _this.checkOnline,
              logger: _this.logger
            });
            return _this.statusDevice.start(function(error) {
              if (error != null) {
                return _this.emit('error', error);
              }
              return _this.boot(device, callback);
            });
          });
        };
      })(this));
      return this.meshblu.connect();
    };

    Runner.prototype.whoami = function(callback) {
      this.logger.debug('whoami');
      return this.meshblu.whoami((function(_this) {
        return function(device) {
          return callback(null, device);
        };
      })(this));
    };

    Runner.prototype._handleError = function(error) {
      this.logger.error(error);
      return this.emit('error', error);
    };

    return Runner;

  })(EventEmitter);

  module.exports = Runner;

}).call(this);

//# sourceMappingURL=runner.js.map
